package at.jku.ssw.binarytree.test;

import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;

import at.jku.students.binarytree.BinaryTreeUtil;

public class BuildTreeTest {

	@Rule
	public ExpectedException thrown = ExpectedException.none();

	@Test
	public void testBuildTreeMissingValue() {
		int[] inorder = { 0, 1, 3 };
		int[] preorder = { 1, 0, 2 };
		thrown.expect(IllegalArgumentException.class);
		BinaryTreeUtil.buildTree(inorder, preorder);
	}

	@Test
	public void testBuildTreeWrongSize() {
		int[] inorder = { 0, 1 };
		int[] preorder = { 1, 0, 2 };
		thrown.expect(IllegalArgumentException.class);
		BinaryTreeUtil.buildTree(inorder, preorder);
	}

	@Test
	public void testBuildTreeWrongOrders() {
		int[] inorder = { 2, 0, 1 };
		int[] preorder = { 0, 1, 2 };
		thrown.expect(IllegalArgumentException.class);
		BinaryTreeUtil.buildTree(inorder, preorder);
	}
}
